<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>iCelPropertyClass Struct Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">iCelPropertyClass Struct Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="iCelPropertyClass" --><!-- doxytag: inherits="iBase" -->
<p>This is a property class for an entity.  
 <a href="structiCelPropertyClass.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="propclas_8h_source.html">physicallayer/propclas.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for iCelPropertyClass:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structiCelPropertyClass.png" usemap="#iCelPropertyClass_map" alt=""/>
  <map id="iCelPropertyClass_map" name="iCelPropertyClass_map">
<area doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html" alt="iBase" shape="rect" coords="0,0,114,24"/>
</map>
 </div></div>

<p><a href="structiCelPropertyClass-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#ac70770cd5367393b7c5ff8948cc4e8c4">AddPropertyChangeCallback</a> (<a class="el" href="structiCelPropertyChangeCallback.html">iCelPropertyChangeCallback</a> *cb)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Add a callback which will be fired when a property changes.  <a href="#ac70770cd5367393b7c5ff8948cc4e8c4"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="structiCelEntity.html">iCelEntity</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#aedd94ad88ef06ce28c8265dbf786c29a">GetEntity</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the parent entity associated with this property class.  <a href="#aedd94ad88ef06ce28c8265dbf786c29a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#abbbc7a02c9fed6b7faaadef34a5431ca">GetName</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the name of this property class.  <a href="#abbbc7a02c9fed6b7faaadef34a5431ca"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr</a>&lt; <a class="el" href="structiCelDataBuffer.html">iCelDataBuffer</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#aa2c16dfc478ee3f5abfa59adb6cb48e4">GetPersistentData</a> (celPersistenceType persistence_type)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the persistent data of this property class.  <a href="#aa2c16dfc478ee3f5abfa59adb6cb48e4"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#a9ac210ddf1bcc7b2f81fce00a86e20d3">GetPropertyAndActionCount</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the number of supported properties and actions.  <a href="#a9ac210ddf1bcc7b2f81fce00a86e20d3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#a22695e69c30bc5cfd13aed6fc75dce2e">GetPropertyBoolByID</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> propertyID)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a property as bool.  <a href="#a22695e69c30bc5cfd13aed6fc75dce2e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#a19fd53e71b18c86882865e543fff5370">GetPropertyColorByID</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> propertyID, <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsColor.html">csColor</a> &amp;v)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a property as a color.  <a href="#a19fd53e71b18c86882865e543fff5370"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="structiCelEntity.html">iCelEntity</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#af0d10f8aad18f05f8c8e8ca430d8ea69">GetPropertyEntityByID</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> propertyID)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a property as entity.  <a href="#af0d10f8aad18f05f8c8e8ca430d8ea69"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#ac1d065d484f8a66f3db15b2a2c7927ff">GetPropertyFloatByID</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> propertyID)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a property as float.  <a href="#ac1d065d484f8a66f3db15b2a2c7927ff"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#aff8191d0544f1b861f151985cb5f6b50">GetPropertyIBaseByID</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> propertyID)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a property as <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>.  <a href="#aff8191d0544f1b861f151985cb5f6b50"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#ab66ae5334a74e23fb1bf1731c28a62ef">GetPropertyLongByID</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> propertyID)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a property as long.  <a href="#ab66ae5334a74e23fb1bf1731c28a62ef"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#abf9bde220adcd2dd2234b63eb2e88b03">GetPropertyOrActionDescription</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the description of the given property or action.  <a href="#abf9bde220adcd2dd2234b63eb2e88b03"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#a2219a9b1961fcd08e790cc9b89902f8c">GetPropertyOrActionID</a> (size_t i)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the ID of the given property or action.  <a href="#a2219a9b1961fcd08e790cc9b89902f8c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual celDataType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#a1fb38848eebfa5475c52df4ce1ff3fa1">GetPropertyOrActionType</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> propertyID)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the type of the given property or action.  <a href="#a1fb38848eebfa5475c52df4ce1ff3fa1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="structiCelPropertyClass.html">iCelPropertyClass</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#a024696a20e287d373daf17dea43d3232">GetPropertyPClassByID</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> propertyID)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a property as property class.  <a href="#a024696a20e287d373daf17dea43d3232"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#a29dfac8cc28fbb1c572868d32fad350e">GetPropertyStringByID</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> propertyID)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a property as string.  <a href="#a29dfac8cc28fbb1c572868d32fad350e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#a104c2170cec3a98191bab896c651c052">GetPropertyVectorByID</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> propertyID, <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector2.html">csVector2</a> &amp;v)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a property as a 2D vector.  <a href="#a104c2170cec3a98191bab896c651c052"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#a5a89a282cd5e4288668285169a3cb4fb">GetPropertyVectorByID</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> propertyID, <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;v)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a property as a 3D vector.  <a href="#a5a89a282cd5e4288668285169a3cb4fb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#a852cb0ae0e167bd91228442bc9f2b983">GetTag</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the tag of this property class or return 0 if there is no tag.  <a href="#a852cb0ae0e167bd91228442bc9f2b983"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#a84c10b3e2da530d5e704691cf2277544">IsPropertyReadOnly</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> propertyID)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return true if a property is read-only.  <a href="#a84c10b3e2da530d5e704691cf2277544"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#adf8f476c98087ee14ab57841757c1885">Load</a> (<a class="el" href="structiCelDataBuffer.html">iCelDataBuffer</a> *databuf)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Load this object from a data buffer.  <a href="#adf8f476c98087ee14ab57841757c1885"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#aee594ba4ddae27c61d7a7d20f526e826">LoadFirstPass</a> (<a class="el" href="structiCelDataBuffer.html">iCelDataBuffer</a> *databuf)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Load this object from a data buffer.  <a href="#aee594ba4ddae27c61d7a7d20f526e826"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#a4c92554e60d83f4e69dd442360ae0956">PerformAction</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> actionID, <a class="el" href="structiCelParameterBlock.html">iCelParameterBlock</a> *params, <a class="el" href="structcelData.html">celData</a> &amp;ret)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Perform an action with a generic string parameter.  <a href="#a4c92554e60d83f4e69dd442360ae0956"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#af530504ecbc1b499e0bb230b11db1548">PropertyClassesHaveChanged</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">This method is called by the parent entity when there is a change in property class setting.  <a href="#af530504ecbc1b499e0bb230b11db1548"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiObject.html">iObject</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#ab2c23f0735d20cf2cf7ff6932cb5388b">QueryObject</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the associated <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiObject.html">iObject</a> from this property class.  <a href="#ab2c23f0735d20cf2cf7ff6932cb5388b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#abfe26c6414dca745816cd65b40df94a7">RemovePropertyChangeCallback</a> (<a class="el" href="structiCelPropertyChangeCallback.html">iCelPropertyChangeCallback</a> *cb)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove a callback.  <a href="#abfe26c6414dca745816cd65b40df94a7"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr</a>&lt; <a class="el" href="structiCelDataBuffer.html">iCelDataBuffer</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#a8c5e094d742ab099be618f3327f4fd54">Save</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Save this object to a data buffer.  <a href="#a8c5e094d742ab099be618f3327f4fd54"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr</a>&lt; <a class="el" href="structiCelDataBuffer.html">iCelDataBuffer</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#af9edd0e77d8046e9b1fe05ff23a2927a">SaveFirstPass</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Save this object to a data buffer.  <a href="#af9edd0e77d8046e9b1fe05ff23a2927a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#a898a39b6e49e36ed54cf3dd3966cc334">SetEntity</a> (<a class="el" href="structiCelEntity.html">iCelEntity</a> *entity)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the entity for this property class.  <a href="#a898a39b6e49e36ed54cf3dd3966cc334"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#a90dace25f236f7940672d34dee9bb53c">SetName</a> (const char *name)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the name of this property class.  <a href="#a90dace25f236f7940672d34dee9bb53c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual celPersistenceResult&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#a460573f03fe5b2b85c0bee31c35c938a">SetPersistentData</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> data_time, <a class="el" href="structiCelDataBuffer.html">iCelDataBuffer</a> *data, celPersistenceType persistence_type)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Read the state of this property class from some persistent data.  <a href="#a460573f03fe5b2b85c0bee31c35c938a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#ae5923aa79bf54d542cb6d760fe444b40">SetProperty</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> propertyID, long value)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set a generic property.  <a href="#ae5923aa79bf54d542cb6d760fe444b40"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#ae48352529c0dc20286260849b6b625d8">SetProperty</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> propertyID, float value)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set a generic property.  <a href="#ae48352529c0dc20286260849b6b625d8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#a85196fecdf0d1cc32a994284e986dcfd">SetProperty</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> propertyID, bool value)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set a generic property.  <a href="#a85196fecdf0d1cc32a994284e986dcfd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#ac74d975a95d98de9223941792418b8d0">SetProperty</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> propertyID, const char *value)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set a generic property.  <a href="#ac74d975a95d98de9223941792418b8d0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#aeb1f04adb0177905a61a4a97c4362d0f">SetProperty</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> propertyID, const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector2.html">csVector2</a> &amp;value)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set a generic property.  <a href="#aeb1f04adb0177905a61a4a97c4362d0f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#a906edd96f54af7b4eb78064c8f15e6a7">SetProperty</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> propertyID, const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;value)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set a generic property.  <a href="#a906edd96f54af7b4eb78064c8f15e6a7"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#a58dfee00b8fc5c4488865bf58a091d72">SetProperty</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> propertyID, const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsColor.html">csColor</a> &amp;value)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set a generic property.  <a href="#a58dfee00b8fc5c4488865bf58a091d72"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#ad48ae52e45efdcc8ffa8aa8575b994a8">SetProperty</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> propertyID, <a class="el" href="structiCelPropertyClass.html">iCelPropertyClass</a> *value)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set a generic property.  <a href="#ad48ae52e45efdcc8ffa8aa8575b994a8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#ae1de1b4180c01ac04e1e5bcd5fd3ed74">SetProperty</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> propertyID, <a class="el" href="structiCelEntity.html">iCelEntity</a> *entity)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set a generic property.  <a href="#ae1de1b4180c01ac04e1e5bcd5fd3ed74"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#a03b527f0e56b03af2b01c38fa71e6e70">SetProperty</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> propertyID, <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a> *ibase)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set a generic property.  <a href="#a03b527f0e56b03af2b01c38fa71e6e70"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelPropertyClass.html#adf05a4da86fc02ddbb9a71f954f57a22">SetTag</a> (const char *tagname)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the optional tag of this property class.  <a href="#adf05a4da86fc02ddbb9a71f954f57a22"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This is a property class for an entity. </p>
<p>A property class describe physical attributes of an entity. </p>

<p>Definition at line <a class="el" href="propclas_8h_source.html#l00105">105</a> of file <a class="el" href="propclas_8h_source.html">propclas.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="ac70770cd5367393b7c5ff8948cc4e8c4"></a><!-- doxytag: member="iCelPropertyClass::AddPropertyChangeCallback" ref="ac70770cd5367393b7c5ff8948cc4e8c4" args="(iCelPropertyChangeCallback *cb)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiCelPropertyClass.html#ac70770cd5367393b7c5ff8948cc4e8c4">iCelPropertyClass::AddPropertyChangeCallback</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiCelPropertyChangeCallback.html">iCelPropertyChangeCallback</a> *&#160;</td>
          <td class="paramname"><em>cb</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add a callback which will be fired when a property changes. </p>
<p>Not all property class implementations actually have properties. It is safe to call this function with the same callback (nothing will happen in that case and false will be returned). Otherwise this function will IncRef the callback. </p>

</div>
</div>
<a class="anchor" id="aedd94ad88ef06ce28c8265dbf786c29a"></a><!-- doxytag: member="iCelPropertyClass::GetEntity" ref="aedd94ad88ef06ce28c8265dbf786c29a" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="structiCelEntity.html">iCelEntity</a>* <a class="el" href="structiCelPropertyClass.html#aedd94ad88ef06ce28c8265dbf786c29a">iCelPropertyClass::GetEntity</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the parent entity associated with this property class. </p>

</div>
</div>
<a class="anchor" id="abbbc7a02c9fed6b7faaadef34a5431ca"></a><!-- doxytag: member="iCelPropertyClass::GetName" ref="abbbc7a02c9fed6b7faaadef34a5431ca" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const char* <a class="el" href="structiCelPropertyClass.html#abbbc7a02c9fed6b7faaadef34a5431ca">iCelPropertyClass::GetName</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the name of this property class. </p>

</div>
</div>
<a class="anchor" id="aa2c16dfc478ee3f5abfa59adb6cb48e4"></a><!-- doxytag: member="iCelPropertyClass::GetPersistentData" ref="aa2c16dfc478ee3f5abfa59adb6cb48e4" args="(celPersistenceType persistence_type)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr</a>&lt;<a class="el" href="structiCelDataBuffer.html">iCelDataBuffer</a>&gt; <a class="el" href="structiCelPropertyClass.html#aa2c16dfc478ee3f5abfa59adb6cb48e4">iCelPropertyClass::GetPersistentData</a> </td>
          <td>(</td>
          <td class="paramtype">celPersistenceType&#160;</td>
          <td class="paramname"><em>persistence_type</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the persistent data of this property class. </p>
<p>Note: this function replaces the Save function. </p>

</div>
</div>
<a class="anchor" id="a9ac210ddf1bcc7b2f81fce00a86e20d3"></a><!-- doxytag: member="iCelPropertyClass::GetPropertyAndActionCount" ref="a9ac210ddf1bcc7b2f81fce00a86e20d3" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual size_t <a class="el" href="structiCelPropertyClass.html#a9ac210ddf1bcc7b2f81fce00a86e20d3">iCelPropertyClass::GetPropertyAndActionCount</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the number of supported properties and actions. </p>

</div>
</div>
<a class="anchor" id="a22695e69c30bc5cfd13aed6fc75dce2e"></a><!-- doxytag: member="iCelPropertyClass::GetPropertyBoolByID" ref="a22695e69c30bc5cfd13aed6fc75dce2e" args="(csStringID propertyID)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiCelPropertyClass.html#a22695e69c30bc5cfd13aed6fc75dce2e">iCelPropertyClass::GetPropertyBoolByID</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>propertyID</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a property as bool. </p>

</div>
</div>
<a class="anchor" id="a19fd53e71b18c86882865e543fff5370"></a><!-- doxytag: member="iCelPropertyClass::GetPropertyColorByID" ref="a19fd53e71b18c86882865e543fff5370" args="(csStringID propertyID, csColor &amp;v)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiCelPropertyClass.html#a19fd53e71b18c86882865e543fff5370">iCelPropertyClass::GetPropertyColorByID</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>propertyID</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsColor.html">csColor</a> &amp;&#160;</td>
          <td class="paramname"><em>v</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a property as a color. </p>

</div>
</div>
<a class="anchor" id="af0d10f8aad18f05f8c8e8ca430d8ea69"></a><!-- doxytag: member="iCelPropertyClass::GetPropertyEntityByID" ref="af0d10f8aad18f05f8c8e8ca430d8ea69" args="(csStringID propertyID)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="structiCelEntity.html">iCelEntity</a>* <a class="el" href="structiCelPropertyClass.html#af0d10f8aad18f05f8c8e8ca430d8ea69">iCelPropertyClass::GetPropertyEntityByID</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>propertyID</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a property as entity. </p>

</div>
</div>
<a class="anchor" id="ac1d065d484f8a66f3db15b2a2c7927ff"></a><!-- doxytag: member="iCelPropertyClass::GetPropertyFloatByID" ref="ac1d065d484f8a66f3db15b2a2c7927ff" args="(csStringID propertyID)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual float <a class="el" href="structiCelPropertyClass.html#ac1d065d484f8a66f3db15b2a2c7927ff">iCelPropertyClass::GetPropertyFloatByID</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>propertyID</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a property as float. </p>

</div>
</div>
<a class="anchor" id="aff8191d0544f1b861f151985cb5f6b50"></a><!-- doxytag: member="iCelPropertyClass::GetPropertyIBaseByID" ref="aff8191d0544f1b861f151985cb5f6b50" args="(csStringID propertyID)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>* <a class="el" href="structiCelPropertyClass.html#aff8191d0544f1b861f151985cb5f6b50">iCelPropertyClass::GetPropertyIBaseByID</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>propertyID</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a property as <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>. </p>

</div>
</div>
<a class="anchor" id="ab66ae5334a74e23fb1bf1731c28a62ef"></a><!-- doxytag: member="iCelPropertyClass::GetPropertyLongByID" ref="ab66ae5334a74e23fb1bf1731c28a62ef" args="(csStringID propertyID)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual long <a class="el" href="structiCelPropertyClass.html#ab66ae5334a74e23fb1bf1731c28a62ef">iCelPropertyClass::GetPropertyLongByID</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>propertyID</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a property as long. </p>

</div>
</div>
<a class="anchor" id="abf9bde220adcd2dd2234b63eb2e88b03"></a><!-- doxytag: member="iCelPropertyClass::GetPropertyOrActionDescription" ref="abf9bde220adcd2dd2234b63eb2e88b03" args="(csStringID)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const char* <a class="el" href="structiCelPropertyClass.html#abf9bde220adcd2dd2234b63eb2e88b03">iCelPropertyClass::GetPropertyOrActionDescription</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the description of the given property or action. </p>

</div>
</div>
<a class="anchor" id="a2219a9b1961fcd08e790cc9b89902f8c"></a><!-- doxytag: member="iCelPropertyClass::GetPropertyOrActionID" ref="a2219a9b1961fcd08e790cc9b89902f8c" args="(size_t i)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> <a class="el" href="structiCelPropertyClass.html#a2219a9b1961fcd08e790cc9b89902f8c">iCelPropertyClass::GetPropertyOrActionID</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>i</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the ID of the given property or action. </p>

</div>
</div>
<a class="anchor" id="a1fb38848eebfa5475c52df4ce1ff3fa1"></a><!-- doxytag: member="iCelPropertyClass::GetPropertyOrActionType" ref="a1fb38848eebfa5475c52df4ce1ff3fa1" args="(csStringID propertyID)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual celDataType <a class="el" href="structiCelPropertyClass.html#a1fb38848eebfa5475c52df4ce1ff3fa1">iCelPropertyClass::GetPropertyOrActionType</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>propertyID</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the type of the given property or action. </p>
<p>Returns CEL_DATA_NONE if property is not supported. Only the following types are supported:</p>
<ul>
<li>CEL_DATA_LONG</li>
<li>CEL_DATA_FLOAT</li>
<li>CEL_DATA_BOOL</li>
<li>CEL_DATA_STRING</li>
<li>CEL_DATA_VECTOR2</li>
<li>CEL_DATA_VECTOR3</li>
<li>CEL_DATA_COLOR</li>
<li>CEL_DATA_ACTION</li>
<li>CEL_DATA_PCLASS</li>
<li>CEL_DATA_ENTITY </li>
</ul>

</div>
</div>
<a class="anchor" id="a024696a20e287d373daf17dea43d3232"></a><!-- doxytag: member="iCelPropertyClass::GetPropertyPClassByID" ref="a024696a20e287d373daf17dea43d3232" args="(csStringID propertyID)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="structiCelPropertyClass.html">iCelPropertyClass</a>* <a class="el" href="structiCelPropertyClass.html#a024696a20e287d373daf17dea43d3232">iCelPropertyClass::GetPropertyPClassByID</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>propertyID</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a property as property class. </p>

</div>
</div>
<a class="anchor" id="a29dfac8cc28fbb1c572868d32fad350e"></a><!-- doxytag: member="iCelPropertyClass::GetPropertyStringByID" ref="a29dfac8cc28fbb1c572868d32fad350e" args="(csStringID propertyID)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const char* <a class="el" href="structiCelPropertyClass.html#a29dfac8cc28fbb1c572868d32fad350e">iCelPropertyClass::GetPropertyStringByID</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>propertyID</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a property as string. </p>

</div>
</div>
<a class="anchor" id="a104c2170cec3a98191bab896c651c052"></a><!-- doxytag: member="iCelPropertyClass::GetPropertyVectorByID" ref="a104c2170cec3a98191bab896c651c052" args="(csStringID propertyID, csVector2 &amp;v)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiCelPropertyClass.html#a104c2170cec3a98191bab896c651c052">iCelPropertyClass::GetPropertyVectorByID</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>propertyID</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector2.html">csVector2</a> &amp;&#160;</td>
          <td class="paramname"><em>v</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a property as a 2D vector. </p>

</div>
</div>
<a class="anchor" id="a5a89a282cd5e4288668285169a3cb4fb"></a><!-- doxytag: member="iCelPropertyClass::GetPropertyVectorByID" ref="a5a89a282cd5e4288668285169a3cb4fb" args="(csStringID propertyID, csVector3 &amp;v)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiCelPropertyClass.html#a104c2170cec3a98191bab896c651c052">iCelPropertyClass::GetPropertyVectorByID</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>propertyID</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td>
          <td class="paramname"><em>v</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a property as a 3D vector. </p>

</div>
</div>
<a class="anchor" id="a852cb0ae0e167bd91228442bc9f2b983"></a><!-- doxytag: member="iCelPropertyClass::GetTag" ref="a852cb0ae0e167bd91228442bc9f2b983" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const char* <a class="el" href="structiCelPropertyClass.html#a852cb0ae0e167bd91228442bc9f2b983">iCelPropertyClass::GetTag</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the tag of this property class or return 0 if there is no tag. </p>

</div>
</div>
<a class="anchor" id="a84c10b3e2da530d5e704691cf2277544"></a><!-- doxytag: member="iCelPropertyClass::IsPropertyReadOnly" ref="a84c10b3e2da530d5e704691cf2277544" args="(csStringID propertyID)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiCelPropertyClass.html#a84c10b3e2da530d5e704691cf2277544">iCelPropertyClass::IsPropertyReadOnly</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>propertyID</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return true if a property is read-only. </p>

</div>
</div>
<a class="anchor" id="adf8f476c98087ee14ab57841757c1885"></a><!-- doxytag: member="iCelPropertyClass::Load" ref="adf8f476c98087ee14ab57841757c1885" args="(iCelDataBuffer *databuf)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiCelPropertyClass.html#adf8f476c98087ee14ab57841757c1885">iCelPropertyClass::Load</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiCelDataBuffer.html">iCelDataBuffer</a> *&#160;</td>
          <td class="paramname"><em>databuf</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Load this object from a data buffer. </p>

</div>
</div>
<a class="anchor" id="aee594ba4ddae27c61d7a7d20f526e826"></a><!-- doxytag: member="iCelPropertyClass::LoadFirstPass" ref="aee594ba4ddae27c61d7a7d20f526e826" args="(iCelDataBuffer *databuf)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiCelPropertyClass.html#aee594ba4ddae27c61d7a7d20f526e826">iCelPropertyClass::LoadFirstPass</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiCelDataBuffer.html">iCelDataBuffer</a> *&#160;</td>
          <td class="paramname"><em>databuf</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Load this object from a data buffer. </p>
<p>This is the first pass version. Most property classes will return 0 here. </p>

</div>
</div>
<a class="anchor" id="a4c92554e60d83f4e69dd442360ae0956"></a><!-- doxytag: member="iCelPropertyClass::PerformAction" ref="a4c92554e60d83f4e69dd442360ae0956" args="(csStringID actionID, iCelParameterBlock *params, celData &amp;ret)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiCelPropertyClass.html#a4c92554e60d83f4e69dd442360ae0956">iCelPropertyClass::PerformAction</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>actionID</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structiCelParameterBlock.html">iCelParameterBlock</a> *&#160;</td>
          <td class="paramname"><em>params</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structcelData.html">celData</a> &amp;&#160;</td>
          <td class="paramname"><em>ret</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Perform an action with a generic string parameter. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">actionID</td><td>the id of the action. </td></tr>
    <tr><td class="paramname">params</td><td>an optional parameter block for this action. </td></tr>
    <tr><td class="paramname">ret</td><td>is an optional return value. Note! Make sure to clear this variable before calling. <a class="el" href="structiCelPropertyClass.html#a4c92554e60d83f4e69dd442360ae0956" title="Perform an action with a generic string parameter.">PerformAction()</a> implementations can choose not to initialize it. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="af530504ecbc1b499e0bb230b11db1548"></a><!-- doxytag: member="iCelPropertyClass::PropertyClassesHaveChanged" ref="af530504ecbc1b499e0bb230b11db1548" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelPropertyClass.html#af530504ecbc1b499e0bb230b11db1548">iCelPropertyClass::PropertyClassesHaveChanged</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>This method is called by the parent entity when there is a change in property class setting. </p>
<p>i.e. another property class has been added or removed from the entity. This allows this property class to make adjustments to the references it keeps internally for other property classes. </p>

</div>
</div>
<a class="anchor" id="ab2c23f0735d20cf2cf7ff6932cb5388b"></a><!-- doxytag: member="iCelPropertyClass::QueryObject" ref="ab2c23f0735d20cf2cf7ff6932cb5388b" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiObject.html">iObject</a>* <a class="el" href="structiCelPropertyClass.html#ab2c23f0735d20cf2cf7ff6932cb5388b">iCelPropertyClass::QueryObject</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the associated <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiObject.html">iObject</a> from this property class. </p>

</div>
</div>
<a class="anchor" id="abfe26c6414dca745816cd65b40df94a7"></a><!-- doxytag: member="iCelPropertyClass::RemovePropertyChangeCallback" ref="abfe26c6414dca745816cd65b40df94a7" args="(iCelPropertyChangeCallback *cb)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiCelPropertyClass.html#abfe26c6414dca745816cd65b40df94a7">iCelPropertyClass::RemovePropertyChangeCallback</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiCelPropertyChangeCallback.html">iCelPropertyChangeCallback</a> *&#160;</td>
          <td class="paramname"><em>cb</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Remove a callback. </p>
<p>It is safe to call this function for a callback that is not registered. Nothing will happen in that case (except that false is returned). This function will DecRef the callback if it was present. </p>

</div>
</div>
<a class="anchor" id="a8c5e094d742ab099be618f3327f4fd54"></a><!-- doxytag: member="iCelPropertyClass::Save" ref="a8c5e094d742ab099be618f3327f4fd54" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr</a>&lt;<a class="el" href="structiCelDataBuffer.html">iCelDataBuffer</a>&gt; <a class="el" href="structiCelPropertyClass.html#a8c5e094d742ab099be618f3327f4fd54">iCelPropertyClass::Save</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Save this object to a data buffer. </p>

</div>
</div>
<a class="anchor" id="af9edd0e77d8046e9b1fe05ff23a2927a"></a><!-- doxytag: member="iCelPropertyClass::SaveFirstPass" ref="af9edd0e77d8046e9b1fe05ff23a2927a" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr</a>&lt;<a class="el" href="structiCelDataBuffer.html">iCelDataBuffer</a>&gt; <a class="el" href="structiCelPropertyClass.html#af9edd0e77d8046e9b1fe05ff23a2927a">iCelPropertyClass::SaveFirstPass</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Save this object to a data buffer. </p>
<p>This routine is the first pass saving routine. Few property classes need to implement this. The idea is that here information is saved which is important to make other property classes work. This can be information related to level data that is essential for other property classes. Most property classes will return 0 here. </p>

</div>
</div>
<a class="anchor" id="a898a39b6e49e36ed54cf3dd3966cc334"></a><!-- doxytag: member="iCelPropertyClass::SetEntity" ref="a898a39b6e49e36ed54cf3dd3966cc334" args="(iCelEntity *entity)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelPropertyClass.html#a898a39b6e49e36ed54cf3dd3966cc334">iCelPropertyClass::SetEntity</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiCelEntity.html">iCelEntity</a> *&#160;</td>
          <td class="paramname"><em>entity</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the entity for this property class. </p>

</div>
</div>
<a class="anchor" id="a90dace25f236f7940672d34dee9bb53c"></a><!-- doxytag: member="iCelPropertyClass::SetName" ref="a90dace25f236f7940672d34dee9bb53c" args="(const char *name)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelPropertyClass.html#a90dace25f236f7940672d34dee9bb53c">iCelPropertyClass::SetName</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the name of this property class. </p>

</div>
</div>
<a class="anchor" id="a460573f03fe5b2b85c0bee31c35c938a"></a><!-- doxytag: member="iCelPropertyClass::SetPersistentData" ref="a460573f03fe5b2b85c0bee31c35c938a" args="(csTicks data_time, iCelDataBuffer *data, celPersistenceType persistence_type)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual celPersistenceResult <a class="el" href="structiCelPropertyClass.html#a460573f03fe5b2b85c0bee31c35c938a">iCelPropertyClass::SetPersistentData</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a>&#160;</td>
          <td class="paramname"><em>data_time</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structiCelDataBuffer.html">iCelDataBuffer</a> *&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">celPersistenceType&#160;</td>
          <td class="paramname"><em>persistence_type</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Read the state of this property class from some persistent data. </p>
<p>Note: this function replaces the Load function. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">data_time</td><td>The timestamp of the persistent data. </td></tr>
    <tr><td class="paramname">data</td><td>The persistent data. </td></tr>
    <tr><td class="paramname">persistence_type</td><td>The type of the persistence source. </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>Whether a problem has been encountered or not. Cheats can happen only if the type of the persistence source is CEL_PERSIST_TYPE_CLIENT_CONTROL (ie, when we are on the server side and the entity is controlled by a client). </dd></dl>

</div>
</div>
<a class="anchor" id="ae5923aa79bf54d542cb6d760fe444b40"></a><!-- doxytag: member="iCelPropertyClass::SetProperty" ref="ae5923aa79bf54d542cb6d760fe444b40" args="(csStringID propertyID, long value)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiCelPropertyClass.html#ae5923aa79bf54d542cb6d760fe444b40">iCelPropertyClass::SetProperty</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>propertyID</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">long&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set a generic property. </p>
<p>In order to make it easier to access properties in a property class from general scripting languages this generic interface to properties is provided. It is always faster and more efficient to set properties directly but this system is usable in general.</p>
<p>This function returns false if the property could not be set for some reason.</p>
<p>The physical layer maintains a registry of ID's to use. </p>

</div>
</div>
<a class="anchor" id="ae48352529c0dc20286260849b6b625d8"></a><!-- doxytag: member="iCelPropertyClass::SetProperty" ref="ae48352529c0dc20286260849b6b625d8" args="(csStringID propertyID, float value)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiCelPropertyClass.html#ae5923aa79bf54d542cb6d760fe444b40">iCelPropertyClass::SetProperty</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>propertyID</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set a generic property. </p>

</div>
</div>
<a class="anchor" id="a85196fecdf0d1cc32a994284e986dcfd"></a><!-- doxytag: member="iCelPropertyClass::SetProperty" ref="a85196fecdf0d1cc32a994284e986dcfd" args="(csStringID propertyID, bool value)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiCelPropertyClass.html#ae5923aa79bf54d542cb6d760fe444b40">iCelPropertyClass::SetProperty</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>propertyID</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set a generic property. </p>

</div>
</div>
<a class="anchor" id="ac74d975a95d98de9223941792418b8d0"></a><!-- doxytag: member="iCelPropertyClass::SetProperty" ref="ac74d975a95d98de9223941792418b8d0" args="(csStringID propertyID, const char *value)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiCelPropertyClass.html#ae5923aa79bf54d542cb6d760fe444b40">iCelPropertyClass::SetProperty</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>propertyID</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set a generic property. </p>

</div>
</div>
<a class="anchor" id="aeb1f04adb0177905a61a4a97c4362d0f"></a><!-- doxytag: member="iCelPropertyClass::SetProperty" ref="aeb1f04adb0177905a61a4a97c4362d0f" args="(csStringID propertyID, const csVector2 &amp;value)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiCelPropertyClass.html#ae5923aa79bf54d542cb6d760fe444b40">iCelPropertyClass::SetProperty</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>propertyID</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector2.html">csVector2</a> &amp;&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set a generic property. </p>

</div>
</div>
<a class="anchor" id="a906edd96f54af7b4eb78064c8f15e6a7"></a><!-- doxytag: member="iCelPropertyClass::SetProperty" ref="a906edd96f54af7b4eb78064c8f15e6a7" args="(csStringID propertyID, const csVector3 &amp;value)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiCelPropertyClass.html#ae5923aa79bf54d542cb6d760fe444b40">iCelPropertyClass::SetProperty</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>propertyID</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set a generic property. </p>

</div>
</div>
<a class="anchor" id="a58dfee00b8fc5c4488865bf58a091d72"></a><!-- doxytag: member="iCelPropertyClass::SetProperty" ref="a58dfee00b8fc5c4488865bf58a091d72" args="(csStringID propertyID, const csColor &amp;value)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiCelPropertyClass.html#ae5923aa79bf54d542cb6d760fe444b40">iCelPropertyClass::SetProperty</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>propertyID</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsColor.html">csColor</a> &amp;&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set a generic property. </p>

</div>
</div>
<a class="anchor" id="ad48ae52e45efdcc8ffa8aa8575b994a8"></a><!-- doxytag: member="iCelPropertyClass::SetProperty" ref="ad48ae52e45efdcc8ffa8aa8575b994a8" args="(csStringID propertyID, iCelPropertyClass *value)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiCelPropertyClass.html#ae5923aa79bf54d542cb6d760fe444b40">iCelPropertyClass::SetProperty</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>propertyID</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structiCelPropertyClass.html">iCelPropertyClass</a> *&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set a generic property. </p>

</div>
</div>
<a class="anchor" id="ae1de1b4180c01ac04e1e5bcd5fd3ed74"></a><!-- doxytag: member="iCelPropertyClass::SetProperty" ref="ae1de1b4180c01ac04e1e5bcd5fd3ed74" args="(csStringID propertyID, iCelEntity *entity)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiCelPropertyClass.html#ae5923aa79bf54d542cb6d760fe444b40">iCelPropertyClass::SetProperty</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>propertyID</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structiCelEntity.html">iCelEntity</a> *&#160;</td>
          <td class="paramname"><em>entity</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set a generic property. </p>

</div>
</div>
<a class="anchor" id="a03b527f0e56b03af2b01c38fa71e6e70"></a><!-- doxytag: member="iCelPropertyClass::SetProperty" ref="a03b527f0e56b03af2b01c38fa71e6e70" args="(csStringID propertyID, iBase *ibase)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiCelPropertyClass.html#ae5923aa79bf54d542cb6d760fe444b40">iCelPropertyClass::SetProperty</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>propertyID</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a> *&#160;</td>
          <td class="paramname"><em>ibase</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set a generic property. </p>

</div>
</div>
<a class="anchor" id="adf05a4da86fc02ddbb9a71f954f57a22"></a><!-- doxytag: member="iCelPropertyClass::SetTag" ref="adf05a4da86fc02ddbb9a71f954f57a22" args="(const char *tagname)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelPropertyClass.html#adf05a4da86fc02ddbb9a71f954f57a22">iCelPropertyClass::SetTag</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>tagname</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the optional tag of this property class. </p>
<p>Multiple property classes of the same type (same name) can be attached to the same entity. To do that you need to add a tag so that you can uniquely identify them. </p>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li>physicallayer/<a class="el" href="propclas_8h_source.html">propclas.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
